# This an autogenerated file
# 
# Generated with RegularWaveItem
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.regularwaveitem import RegularWaveItemBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class RegularWaveItem(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    amplitude : float
         Wave amplitude(default 0.0)
    period : float
         Wave period(default 0.0)
    phase : float
         Phase angle according to theory manual(default 0.0)
    direction : float
         Wave propagation direction(default 0.0)
    """

    def __init__(self , description="", amplitude=0.0, period=0.0, phase=0.0, direction=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.amplitude = amplitude
        self.period = period
        self.phase = phase
        self.direction = direction
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return RegularWaveItemBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def amplitude(self) -> float:
        """Wave amplitude"""
        return self.__amplitude

    @amplitude.setter
    def amplitude(self, value: float):
        """Set amplitude"""
        self.__amplitude = float(value)

    @property
    def period(self) -> float:
        """Wave period"""
        return self.__period

    @period.setter
    def period(self, value: float):
        """Set period"""
        self.__period = float(value)

    @property
    def phase(self) -> float:
        """Phase angle according to theory manual"""
        return self.__phase

    @phase.setter
    def phase(self, value: float):
        """Set phase"""
        self.__phase = float(value)

    @property
    def direction(self) -> float:
        """Wave propagation direction"""
        return self.__direction

    @direction.setter
    def direction(self, value: float):
        """Set direction"""
        self.__direction = float(value)
