# This an autogenerated file
# 
# Generated with ExternalHLAFederate
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.externalhlafederate import ExternalHLAFederateBlueprint
from typing import Dict
from sima.hla.hlafederate import HLAFederate
from sima.hla.hlaobject import HLAObject
from sima.sima.scriptablevalue import ScriptableValue

class ExternalHLAFederate(HLAFederate):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    name : str
         (default None)
    timeStep : float
         (default 0.0)
    launch : bool
         Launch federate from provided class(default True)
    jarFile : str
         Path to jar file(default None)
    className : str
         Class name starting HLAFederate(default None)
    classPath : str
         Additional classpath needed by the external jar(default None)
    arguments : str
         Arguments passed to the class' main function(default None)
    libraryPath : str
         Sometimes needed when using native libraries. Corresponds to the -Djava.library.path argument(default None)
    showOutput : bool
         Show output from federate(default False)
    hlaObjects : List[HLAObject]
    """

    def __init__(self , description="", timeStep=0.0, launch=True, showOutput=False, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.name = None
        self.timeStep = timeStep
        self.launch = launch
        self.jarFile = None
        self.className = None
        self.classPath = None
        self.arguments = None
        self.libraryPath = None
        self.showOutput = showOutput
        self.hlaObjects = list()
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return ExternalHLAFederateBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def name(self) -> str:
        """"""
        return self.__name

    @name.setter
    def name(self, value: str):
        """Set name"""
        self.__name = value

    @property
    def timeStep(self) -> float:
        """"""
        return self.__timeStep

    @timeStep.setter
    def timeStep(self, value: float):
        """Set timeStep"""
        self.__timeStep = float(value)

    @property
    def launch(self) -> bool:
        """Launch federate from provided class"""
        return self.__launch

    @launch.setter
    def launch(self, value: bool):
        """Set launch"""
        self.__launch = bool(value)

    @property
    def jarFile(self) -> str:
        """Path to jar file"""
        return self.__jarFile

    @jarFile.setter
    def jarFile(self, value: str):
        """Set jarFile"""
        self.__jarFile = value

    @property
    def className(self) -> str:
        """Class name starting HLAFederate"""
        return self.__className

    @className.setter
    def className(self, value: str):
        """Set className"""
        self.__className = value

    @property
    def classPath(self) -> str:
        """Additional classpath needed by the external jar"""
        return self.__classPath

    @classPath.setter
    def classPath(self, value: str):
        """Set classPath"""
        self.__classPath = value

    @property
    def arguments(self) -> str:
        """Arguments passed to the class' main function"""
        return self.__arguments

    @arguments.setter
    def arguments(self, value: str):
        """Set arguments"""
        self.__arguments = value

    @property
    def libraryPath(self) -> str:
        """Sometimes needed when using native libraries. Corresponds to the -Djava.library.path argument"""
        return self.__libraryPath

    @libraryPath.setter
    def libraryPath(self, value: str):
        """Set libraryPath"""
        self.__libraryPath = value

    @property
    def showOutput(self) -> bool:
        """Show output from federate"""
        return self.__showOutput

    @showOutput.setter
    def showOutput(self, value: bool):
        """Set showOutput"""
        self.__showOutput = bool(value)

    @property
    def hlaObjects(self) -> List[HLAObject]:
        """"""
        return self.__hlaObjects

    @hlaObjects.setter
    def hlaObjects(self, value: List[HLAObject]):
        """Set hlaObjects"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__hlaObjects = value
