# This an autogenerated file
# 
# Generated with QTFDof
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.qtfdof import QTFDofBlueprint
from numpy import ndarray,asarray
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class QTFDof(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    nValues : int
         (default 0)
    re : ndarray
    im : ndarray
    """

    def __init__(self , description="", nValues=0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.nValues = nValues
        self.re = ndarray(1)
        self.im = ndarray(1)
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return QTFDofBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def nValues(self) -> int:
        """"""
        return self.__nValues

    @nValues.setter
    def nValues(self, value: int):
        """Set nValues"""
        self.__nValues = int(value)

    @property
    def re(self) -> ndarray:
        """"""
        return self.__re

    @re.setter
    def re(self, value: ndarray):
        """Set re"""
        self.__re = asarray(value)

    @property
    def im(self) -> ndarray:
        """"""
        return self.__im

    @im.setter
    def im(self, value: ndarray):
        """Set im"""
        self.__im = asarray(value)
