# This an autogenerated file
# 
# Generated with OmniDirectionalExtremeValues
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.omnidirectionalextremevalues import OmniDirectionalExtremeValuesBlueprint
from typing import Dict
from sima.metocean.extremevalue import ExtremeValue
from sima.metocean.levelextreme import LevelExtreme
from sima.sima.scriptablevalue import ScriptableValue

class OmniDirectionalExtremeValues(LevelExtreme):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    name : str
         (default None)
    level : float
         (default 0.0)
    duration : float
         (default 0.0)
    probability : float
         (default 0.0)
    extremeValues : List[ExtremeValue]
    """

    def __init__(self , description="", level=0.0, duration=0.0, probability=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.name = None
        self.level = level
        self.duration = duration
        self.probability = probability
        self.extremeValues = list()
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return OmniDirectionalExtremeValuesBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def name(self) -> str:
        """"""
        return self.__name

    @name.setter
    def name(self, value: str):
        """Set name"""
        self.__name = value

    @property
    def level(self) -> float:
        """"""
        return self.__level

    @level.setter
    def level(self, value: float):
        """Set level"""
        self.__level = float(value)

    @property
    def duration(self) -> float:
        """"""
        return self.__duration

    @duration.setter
    def duration(self, value: float):
        """Set duration"""
        self.__duration = float(value)

    @property
    def probability(self) -> float:
        """"""
        return self.__probability

    @probability.setter
    def probability(self, value: float):
        """Set probability"""
        self.__probability = float(value)

    @property
    def extremeValues(self) -> List[ExtremeValue]:
        """"""
        return self.__extremeValues

    @extremeValues.setter
    def extremeValues(self, value: List[ExtremeValue]):
        """Set extremeValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__extremeValues = value
