# This an autogenerated file
# 
# Generated with BladePitchChangeItem
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.bladepitchchangeitem import BladePitchChangeItemBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class BladePitchChangeItem(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    rate : float
         (default 0.0)
    maximumPitchAngle : float
         Maximum pitch at this rate of pitch change(default 0.0)
    """

    def __init__(self , description="", rate=0.0, maximumPitchAngle=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.rate = rate
        self.maximumPitchAngle = maximumPitchAngle
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return BladePitchChangeItemBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def rate(self) -> float:
        """"""
        return self.__rate

    @rate.setter
    def rate(self, value: float):
        """Set rate"""
        self.__rate = float(value)

    @property
    def maximumPitchAngle(self) -> float:
        """Maximum pitch at this rate of pitch change"""
        return self.__maximumPitchAngle

    @maximumPitchAngle.setter
    def maximumPitchAngle(self, value: float):
        """Set maximumPitchAngle"""
        self.__maximumPitchAngle = float(value)
