# This an autogenerated file
# 
# Generated with CRSAxialDampingItem
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.crsaxialdampingitem import CRSAxialDampingItemBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class CRSAxialDampingItem(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    dampingCoefficient : float
         Damping coefficient corresponding to relative elongation.(default 0.0)
    relativeElongation : float
         Relative elongation(default 0.0)
    """

    def __init__(self , description="", dampingCoefficient=0.0, relativeElongation=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.dampingCoefficient = dampingCoefficient
        self.relativeElongation = relativeElongation
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return CRSAxialDampingItemBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def dampingCoefficient(self) -> float:
        """Damping coefficient corresponding to relative elongation."""
        return self.__dampingCoefficient

    @dampingCoefficient.setter
    def dampingCoefficient(self, value: float):
        """Set dampingCoefficient"""
        self.__dampingCoefficient = float(value)

    @property
    def relativeElongation(self) -> float:
        """Relative elongation"""
        return self.__relativeElongation

    @relativeElongation.setter
    def relativeElongation(self, value: float):
        """Set relativeElongation"""
        self.__relativeElongation = float(value)
