# This an autogenerated file
# 
# Generated with ReynoldStrouhalNumberItem
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.reynoldstrouhalnumberitem import ReynoldStrouhalNumberItemBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class ReynoldStrouhalNumberItem(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    reynoldsNumber : float
         Reynolds number(default 0.0)
    strouhalNumber : float
         Strouhal number(default 0.0)
    """

    def __init__(self , description="", reynoldsNumber=0.0, strouhalNumber=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.reynoldsNumber = reynoldsNumber
        self.strouhalNumber = strouhalNumber
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return ReynoldStrouhalNumberItemBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def reynoldsNumber(self) -> float:
        """Reynolds number"""
        return self.__reynoldsNumber

    @reynoldsNumber.setter
    def reynoldsNumber(self, value: float):
        """Set reynoldsNumber"""
        self.__reynoldsNumber = float(value)

    @property
    def strouhalNumber(self) -> float:
        """Strouhal number"""
        return self.__strouhalNumber

    @strouhalNumber.setter
    def strouhalNumber(self, value: float):
        """Set strouhalNumber"""
        self.__strouhalNumber = float(value)
