# This an autogenerated file
# 
# Generated with AdvancedBumper
from __future__ import annotations
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.advancedbumper import AdvancedBumperBlueprint
from typing import Dict
from sima.sima.namedobject import NamedObject
from sima.sima.point3 import Point3
from sima.sima.scriptablevalue import ScriptableValue
from sima.simo.forcedampingcharacteristic import ForceDampingCharacteristic
from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from sima.simo.simobody import SIMOBody

class AdvancedBumper(NamedObject):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    name : str
         (default None)
    body1 : SIMOBody
    body2 : SIMOBody
    velocityLimit : float
         Velocity limit for friction force (Damping Exponent = 0)(default 0.0)
    characteristic : ForceDampingCharacteristic
    body1End1 : Point3
    body1End2 : Point3
    body2End1 : Point3
    body2End2 : Point3
    """

    def __init__(self , description="", velocityLimit=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.name = None
        self.body1 = None
        self.body2 = None
        self.velocityLimit = velocityLimit
        self.characteristic = None
        self.body1End1 = None
        self.body1End2 = None
        self.body2End1 = None
        self.body2End2 = None
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return AdvancedBumperBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def name(self) -> str:
        """"""
        return self.__name

    @name.setter
    def name(self, value: str):
        """Set name"""
        self.__name = value

    @property
    def body1(self) -> SIMOBody:
        """"""
        return self.__body1

    @body1.setter
    def body1(self, value: SIMOBody):
        """Set body1"""
        self.__body1 = value

    @property
    def body2(self) -> SIMOBody:
        """"""
        return self.__body2

    @body2.setter
    def body2(self, value: SIMOBody):
        """Set body2"""
        self.__body2 = value

    @property
    def velocityLimit(self) -> float:
        """Velocity limit for friction force (Damping Exponent = 0)"""
        return self.__velocityLimit

    @velocityLimit.setter
    def velocityLimit(self, value: float):
        """Set velocityLimit"""
        self.__velocityLimit = float(value)

    @property
    def characteristic(self) -> ForceDampingCharacteristic:
        """"""
        return self.__characteristic

    @characteristic.setter
    def characteristic(self, value: ForceDampingCharacteristic):
        """Set characteristic"""
        self.__characteristic = value

    @property
    def body1End1(self) -> Point3:
        """"""
        return self.__body1End1

    @body1End1.setter
    def body1End1(self, value: Point3):
        """Set body1End1"""
        self.__body1End1 = value

    @property
    def body1End2(self) -> Point3:
        """"""
        return self.__body1End2

    @body1End2.setter
    def body1End2(self, value: Point3):
        """Set body1End2"""
        self.__body1End2 = value

    @property
    def body2End1(self) -> Point3:
        """"""
        return self.__body2End1

    @body2End1.setter
    def body2End1(self, value: Point3):
        """Set body2End1"""
        self.__body2End1 = value

    @property
    def body2End2(self) -> Point3:
        """"""
        return self.__body2End2

    @body2End2.setter
    def body2End2(self, value: Point3):
        """Set body2End2"""
        self.__body2End2 = value
