# This an autogenerated file
# 
# Generated with DistanceKey
from __future__ import annotations
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.distancekey import DistanceKeyBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue
from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from sima.simo.distance import Distance

class DistanceKey(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    horisontalDistance : Distance
    verticalDistance : Distance
    """

    def __init__(self , description="", **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.horisontalDistance = None
        self.verticalDistance = None
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return DistanceKeyBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def horisontalDistance(self) -> Distance:
        """"""
        return self.__horisontalDistance

    @horisontalDistance.setter
    def horisontalDistance(self, value: Distance):
        """Set horisontalDistance"""
        self.__horisontalDistance = value

    @property
    def verticalDistance(self) -> Distance:
        """"""
        return self.__verticalDistance

    @verticalDistance.setter
    def verticalDistance(self, value: Distance):
        """Set verticalDistance"""
        self.__verticalDistance = value
