# This an autogenerated file
# 
# Generated with FlowRateItem
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.flowrateitem import FlowRateItemBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class FlowRateItem(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    time : float
         Time(default 0.0)
    rate : float
         Mass rate used until next time instant(default 0.0)
    """

    def __init__(self , description="", time=0.0, rate=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.time = time
        self.rate = rate
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return FlowRateItemBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def time(self) -> float:
        """Time"""
        return self.__time

    @time.setter
    def time(self, value: float):
        """Set time"""
        self.__time = float(value)

    @property
    def rate(self) -> float:
        """Mass rate used until next time instant"""
        return self.__rate

    @rate.setter
    def rate(self, value: float):
        """Set rate"""
        self.__rate = float(value)
