# This an autogenerated file
# 
# Generated with PeriodEigenvalueResult
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.periodeigenvalueresult import PeriodEigenvalueResultBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class PeriodEigenvalueResult(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    period : float
         Natural period(default 0.0)
    surge : float
         Value in surge (default 0.0)
    sway : float
         Value in sway(default 0.0)
    heave : float
         Value in heave(default 0.0)
    roll : float
         Value in roll(default 0.0)
    pitch : float
         Value in pitch(default 0.0)
    yaw : float
         Value in yaw(default 0.0)
    """

    def __init__(self , description="", period=0.0, surge=0.0, sway=0.0, heave=0.0, roll=0.0, pitch=0.0, yaw=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.period = period
        self.surge = surge
        self.sway = sway
        self.heave = heave
        self.roll = roll
        self.pitch = pitch
        self.yaw = yaw
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return PeriodEigenvalueResultBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def period(self) -> float:
        """Natural period"""
        return self.__period

    @period.setter
    def period(self, value: float):
        """Set period"""
        self.__period = float(value)

    @property
    def surge(self) -> float:
        """Value in surge """
        return self.__surge

    @surge.setter
    def surge(self, value: float):
        """Set surge"""
        self.__surge = float(value)

    @property
    def sway(self) -> float:
        """Value in sway"""
        return self.__sway

    @sway.setter
    def sway(self, value: float):
        """Set sway"""
        self.__sway = float(value)

    @property
    def heave(self) -> float:
        """Value in heave"""
        return self.__heave

    @heave.setter
    def heave(self, value: float):
        """Set heave"""
        self.__heave = float(value)

    @property
    def roll(self) -> float:
        """Value in roll"""
        return self.__roll

    @roll.setter
    def roll(self, value: float):
        """Set roll"""
        self.__roll = float(value)

    @property
    def pitch(self) -> float:
        """Value in pitch"""
        return self.__pitch

    @pitch.setter
    def pitch(self, value: float):
        """Set pitch"""
        self.__pitch = float(value)

    @property
    def yaw(self) -> float:
        """Value in yaw"""
        return self.__yaw

    @yaw.setter
    def yaw(self, value: float):
        """Set yaw"""
        self.__yaw = float(value)
