# This an autogenerated file
# 
# Generated with WamitWave
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.wamitwave import WamitWaveBlueprint
from numpy import ndarray,asarray
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class WamitWave(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    periods : ndarray
         Wave periods
    headings : ndarray
         Wave headings
    """

    def __init__(self , description="", **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.periods = ndarray(1)
        self.headings = ndarray(1)
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return WamitWaveBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def periods(self) -> ndarray:
        """Wave periods"""
        return self.__periods

    @periods.setter
    def periods(self, value: ndarray):
        """Set periods"""
        self.__periods = asarray(value)

    @property
    def headings(self) -> ndarray:
        """Wave headings"""
        return self.__headings

    @headings.setter
    def headings(self, value: ndarray):
        """Set headings"""
        self.__headings = asarray(value)
