# This an autogenerated file
# 
# Generated with GainItem
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.gainitem import GainItemBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class GainItem(MOAO):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    pitchAngle : float
         (default 0.0)
    correctionFactor : float
         (default 0.0)
    """

    def __init__(self , description="", pitchAngle=0.0, correctionFactor=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.pitchAngle = pitchAngle
        self.correctionFactor = correctionFactor
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return GainItemBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def pitchAngle(self) -> float:
        """"""
        return self.__pitchAngle

    @pitchAngle.setter
    def pitchAngle(self, value: float):
        """Set pitchAngle"""
        self.__pitchAngle = float(value)

    @property
    def correctionFactor(self) -> float:
        """"""
        return self.__correctionFactor

    @correctionFactor.setter
    def correctionFactor(self, value: float):
        """Set correctionFactor"""
        self.__correctionFactor = float(value)
