# This an autogenerated file
# 
# Generated with ReportSection
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.reportsection import ReportSectionBlueprint
from typing import Dict
from sima.report.orientation import Orientation
from sima.sima.scriptablevalue import ScriptableValue
from sima.workflow.reportfragmentitem import ReportFragmentItem
from sima.workflow.reportfragmentitemcontainer import ReportFragmentItemContainer

class ReportSection(ReportFragmentItemContainer):
    """
    Keyword arguments
    -----------------
    description : str
         (default "")
    scriptableValues : List[ScriptableValue]
    reportFragmentItems : List[ReportFragmentItem]
    title : str
         (default None)
    pageBreakBefore : bool
         (default False)
    orientation : Orientation
    """

    def __init__(self , description="", pageBreakBefore=False, orientation=Orientation.PORTRAIT, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.scriptableValues = list()
        self.reportFragmentItems = list()
        self.title = None
        self.pageBreakBefore = pageBreakBefore
        self.orientation = orientation
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return ReportSectionBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = value

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def reportFragmentItems(self) -> List[ReportFragmentItem]:
        """"""
        return self.__reportFragmentItems

    @reportFragmentItems.setter
    def reportFragmentItems(self, value: List[ReportFragmentItem]):
        """Set reportFragmentItems"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__reportFragmentItems = value

    @property
    def title(self) -> str:
        """"""
        return self.__title

    @title.setter
    def title(self, value: str):
        """Set title"""
        self.__title = value

    @property
    def pageBreakBefore(self) -> bool:
        """"""
        return self.__pageBreakBefore

    @pageBreakBefore.setter
    def pageBreakBefore(self, value: bool):
        """Set pageBreakBefore"""
        self.__pageBreakBefore = bool(value)

    @property
    def orientation(self) -> Orientation:
        """"""
        return self.__orientation

    @orientation.setter
    def orientation(self, value: Orientation):
        """Set orientation"""
        self.__orientation = value
